<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\BaseExt\Utility;

/**
 * @package     imia_base_ext
 * @subpackage  Utility
 * @author      David Frerich <d.frerich@imia.de>
 */
class BackendTypoScript
{
    /**
     * @var array
     */
    private static $typoScripts = array();

    /**
     * @param integer $pageUid
     * @return array
     */
    static public function get($pageUid)
    {
        if (!array_key_exists($pageUid, self::$typoScripts)) {
            $objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\CMS\Extbase\Object\ObjectManager');
            $pageRepository = $objectManager->create('TYPO3\CMS\Frontend\Page\PageRepository');
            $rootLine = $pageRepository->getRootLine($pageUid);

            $typoScript = $objectManager->create('TYPO3\CMS\Core\TypoScript\ExtendedTemplateService');
            $typoScript->tt_track = 0;
            $typoScript->init();
            $typoScript->runThroughTemplates($rootLine);
            $typoScript->generateConfig();

            self::$typoScripts[$pageUid] = $typoScript->setup;
        }

        return self::$typoScripts[$pageUid];
    }
}